package domain.db;

import domain.DomainException;
import domain.model.Tankstation;

import java.util.ArrayList;
import java.util.List;

public class Organisatie {
    private List<Tankstation> tankstations;

    public Organisatie() {
        tankstations = new ArrayList<>();
        Tankstation GasOil = new Tankstation("GasOil", "Leuven", 1.182);
        Tankstation OliePlus = new Tankstation("OliePlus", "Wilsele", 1.224);
        Tankstation GreenOil = new Tankstation("GreenOil", "Herent", 1.218);
        Tankstation BestOil = new Tankstation("BestOil", "Tienen", 1.203);
        Tankstation JustOil = new Tankstation("JustOil", "Hoegaarden", 1.178);
        this.voegToe(GasOil);
        this.voegToe(OliePlus);
        this.voegToe(GreenOil);
        this.voegToe(BestOil);
        this.voegToe(JustOil);
    }

    public void voegToe(Tankstation tankstation) {
        if (tankstation == null)
            throw new DomainException("Tankstation dat je wil toevoegen bestaat niet");
        tankstations.add(tankstation);
    }

    /**
     * Geef tankstation met gegeven naam
     *
     * @throws DomainException indien naam niet overeenkomt met geregistreerde tankstation
     */
    public Tankstation geefTankstation(String naam) {
        for (Tankstation tankstation : tankstations) {
            if (tankstation.getNaam().equals(naam))
                return tankstation;
        }
        throw new DomainException("Het tankstation met naam '" + naam + "' kan niet gevonden worden");
    }

    public List<Tankstation> geefTankstations() {
        return tankstations;
    }

    public boolean tankstationGeregistreerd(String naam) {
        for (Tankstation tankstation : tankstations) {
            if (tankstation.getNaam().equals(naam))
                return true;
        }
        return false;
    }

    /**
     * Geeft kost van gegeven hoeveelheid dat besteld wordt bij tankstation met gegeven naam
     * Rekent vaste prijs van 1,20 indien tankstation niet geregistreerd is
     */
    public double berekenKost(String naam, double hoeveelheid) {
        if (!tankstationGeregistreerd(naam))
            return hoeveelheid*1.2;
        return geefTankstation(naam).berekenKost(hoeveelheid);
    }
}

